﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

// Added Using Statements.
using System.Data.Objects;
using System.Data.EntityClient;
using System.Data.Common;

namespace TestModelFirst
{
   public partial class Form1 : Form
   {
      public Form1()
      {
         InitializeComponent();
      }

      private void btnAdd_Click(object sender, EventArgs e)
      {
         // Create a new purchase.
         Purchases NewPurchase = new Purchases();
         NewPurchase.Amount = new Decimal(5.99);
         NewPurchase.PurchaseDate = DateTime.Now;

         // Create a new customer and add the purchase.
         Customers NewCustomer = new Customers();
         NewCustomer.CustomerName = "Josh Bailey";

         // Create the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Add the record and save it.
         context.Customers.Add(NewCustomer);
         context.Purchases.Add(NewPurchase);
         context.SaveChanges();

         // Display a success message.
         MessageBox.Show("Record Added");
      }

      private void btnQueryEntitySQL_Click(object sender, EventArgs e)
      {
         // Create the context.
         EntityConnection conn =
             new EntityConnection("name=Rewards2ModelContainer");
         ObjectContext context = new ObjectContext(conn);

         // Define a command string for making the query.
         String EntitySQLCmd =
             "SELECT OC " +
             "FROM Rewards2ModelContainer.ObtainClients('" +
             cbOrderBy.SelectedItem + "') " +
             "AS OC";

         // Create a query object.
         ObjectQuery<DbDataRecord> Query =
             new ObjectQuery<DbDataRecord>(EntitySQLCmd, context);

         // Execute the query.
         ObjectResult<DbDataRecord> Result = Query.Execute(MergeOption.NoTracking);

         // Define an output string.
         StringBuilder Output = new StringBuilder();

         // Enumerate the records and add them to the output.
         foreach (var Record in Result)
         {
            // Cast the first item in the record as the proper type.
            ObtainClients_Result ThisRow = (ObtainClients_Result)Record[0];

            // Add the individual Items.
            Output.Append(ThisRow.CustomerName + " ID " +
               ThisRow.CustomersId + " purchased " +
               ThisRow.Amount + " on " +
               ThisRow.PurchaseDate + ".\r\n");
         }

         // Display the customer name on screen.
         MessageBox.Show(Output.ToString());
      }

      private void btnQueryLINQ_Click(object sender, EventArgs e)
      {
         // Create the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Make the query.
         var PurchaseList =
            from purchase
            in context.ObtainClients(cbOrderBy.SelectedItem.ToString())
            select purchase;

         // Create a string to hold the result.
         StringBuilder Output = new StringBuilder();

         // Parse the result.
         foreach (var PurchaseEntry in PurchaseList)
            Output.Append(
               PurchaseEntry.CustomerName + " ID " +
               PurchaseEntry.CustomersId + " purchased " +
               PurchaseEntry.Amount + " on " +
               PurchaseEntry.PurchaseDate + "\r\n");

         // Display the result on screen.
         MessageBox.Show(Output.ToString());
      }
   }
}
